package com.njcn.prepare.harmonic.api.line.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;

import com.njcn.prepare.harmonic.api.line.ThsSuperviseClient;
import com.njcn.prepare.harmonic.pojo.param.SuperviseParam;
import com.njcn.prepare.harmonic.utils.PrepareEnumUtil;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestBody;

@Slf4j
@Component
public class ThsSuperviseClientFallbackFactory implements FallbackFactory<ThsSuperviseClient> {
    @Override
    public ThsSuperviseClient create(Throwable throwable) {
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (throwable.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) throwable.getCause();
            exceptionEnum = PrepareEnumUtil.getExceptionEnum(businessException.getResult());
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new ThsSuperviseClient() {
            @Override
            public HttpResult<String> initSupervise(@RequestBody @Validated SuperviseParam superviseParam) {
                log.error("{}异常，降级处理，异常为：{}", "预警/告警事务的初始化:  ", throwable.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<String> creatSupervise(SuperviseParam superviseParam) {
                log.error("{}异常，降级处理，异常为：{}", "预警/告警事务的生成:  ", throwable.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
